<?php
require_once(PAGE_FOLDER."lib/db.manager.php");

$ATTEMPTS_NUMBER = 5;

if (!function_exists('hex2bin')) { function hex2bin($hex) { return pack('H*', $hex);} }

defined("PAGE_FOLDER") ? null : define("PAGE_FOLDER", "");
defined("CEPWEB_XTRA_KEY") ? null : define("CEPWEB_XTRA_KEY", hex2bin("0a99088ea3c0d4591212ca7cceb3891e7a83ec8087cedb331f2824f7ea652da7"));
defined("CEPWEB_COOKIE_NAME") ? null : define("CEPWEB_COOKIE_NAME", "CEPWEB_Cookie");

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;

require_once PAGE_FOLDER.'lib/vendor/autoload.php';

$mail = new PHPMailer;

require_once(PAGE_FOLDER."lib/functions.php");
require_once(PAGE_FOLDER."init.php");
require_once(PAGE_FOLDER."inc/mail_functions.php");
require_once(PAGE_FOLDER."inc/class.newcrypto.php");
require_once(PAGE_FOLDER."inc/session_check.php");

//CONFIGURATION for CEPWeb UI

//ribbon breadcrumbs config
//array("Display Name" => "URL");
$breadcrumbs = array(
    "Home" => "frmmainCepweb.php" //APP_URL
);

/*navigation array config

ex:
"dashboard" => array(
    "title" => "Display Title",
    "url" => "http://yoururl.com",
    "url_target" => "_self",
    "icon" => "fa-home",
    "label_htm" => "<span>Add your custom label/badge html here</span>",
    "sub" => array() //contains array of sub items with the same format as the parent
)

*/
$page_nav = array(
    "inicio" => array(
        "title" => "Inicio",
        "icon" => "fa-home",
        "url" => "frmmainCepweb.php"
    ),
	"speedmodeonly" => array(
        "title" => "Búsqueda global",
        "icon" => "fa-bolt",
        "url" => "searchspeedmode.php"
    ),
	"tesauro" => array(
        "title" => "Vocabulario Jurídico",
        "icon" => "fa fa-text-width",
        "url" => "searchstesauro.php"
    ),	
    "novedades" => array(
        "title" => "Novedades Jurídicas",
        "icon" => "fa-bullhorn",
		"url" => "frmSearchCepwebNJ.php"
    ),
    "bibliotecas" => array(
        "title" => "Publicaciones Oficiales",
        "icon" => "fa fa-file-pdf-o",
		"url" => "frmSearchCepwebBB.php"
    ),	
    "legislacion" => array(
        "title" => "Legislaci&oacute;n",
        "icon" => "fa-balance-scale",
		"sub" => array(
           "LVLV" => array(
                'title' => 'Legislación Nacional',
                'url' => "frmSearchCepwebLV.php"
            ),
	       "LVLI" => array(
                'title' => 'Legislación Internacional',
                'url' => "frmSearchCepwebLI.php"
            ),
		  "LVLC" => array(
                'title' => 'Legislación Comparada',
                'url' => "frmSearchCepwebLC.php"
            ),
		  "LVSA" => array(
                'title' => 'Subregional Andino',
                'url' => "frmSearchCepwebSA.php"
            )
        )
    ),
    "doctrina" => array(
        "title" => "Doctrina",
        "icon" => "fa-book",
		"url" => "frmSearchDoctrina.php"
    ),
    "jurisprudencia" => array(
        "title" => "Jurisprudencia",
        "icon" => "fa-gavel",
		"url" => "frmSearchCepwebJP.php"
     ),
    "info.practica" => array(
        "title" => "Informaci&oacute;n Pr&aacute;ctica",
        "icon" => "fa-lightbulb-o",
        "url" => "frmSearchInfPratica.php"
    ),
	"info.catalogo" => array(
        "title" => "Cat&aacute;logo de delitos",
        "icon" => "fa fa-user-times",
        "url" => "frmSearchCepwebCD.php"
    ),
	"info.diccionario" => array(
        "title" => "Diccionario Jurídico",
        "icon" => "fa fa-hand-o-right",
        "url" => "frmSearchCepwebDC.php"
    )
);

//configuration variables
$page_title = "";
$page_css = array();
$no_main_header = false; //set true for lock.php and login.php
$page_body_prop = array("class"=>$xtra_ontop." fixed-header fixed-navigation"); //optional properties for <body>
$page_html_prop = array(); //optional properties for <html>

?>