<?
//include_once($xtra_subfolder.'lib/class.CompareNew.php');    //array based string comparison
include_once('class.CompareNew.php');    //array based string comparison

$Cksum="CEPWEB77377374888283938u73ue37yhue7";

function encode($x) {
    global $Cksum;
    return strtr(base64_encode(substr($Cksum,rand(0,28),4) . $x), '+/=', '-_~');
}

function decode($x) {
  global $Cksum;
  $y = base64_decode(strtr($x, '-_~', '+/='));
  if (substr($y,0,4)!=''){
      $pos = strpos($Cksum,substr($y,0,4));
      if($pos === false){
          return false;
      }
  }

  $y=substr($y,4-strlen($y));
  return $y;
}

function generateRandomString($length = 10) {
    $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ#$%&/()=?¡*+[]_-:.,;';
    $randomString = '';
    for ($i = 0; $i < $length; $i++) {
	$randomString .= $characters[rand(0, strlen($characters) - 1)];
    }
    return $randomString;
}

function email_encode_data($str){
	$temp = array();
	$str = strval($str);
	for($i=0; $i<strlen($str); $i++) {
		$temp[$i] = $str[$i].generateRandomString(1);
	}
	$temp = implode('',$temp);
	return encode(generateRandomString(1).$temp);
}

function email_decode_data($str){
	$str=decode($str);
	$temp = array();
	for($i=0; $i<strlen($str); $i++) {
		if($i>0 && $i%2!=0) {
			$temp[$i] = $str[$i];
		}
	}
	$temp = implode('',$temp);
	return $temp;
}

function TruncateText($string, $limit, $break=" ", $pad="...") {
    // return with no change if string is shorter than $limit
    if(strlen($string) <= $limit) return $string;

    $string = substr($string, 0, $limit);
    if(false !== ($breakpoint = strrpos($string, $break))) {
      $string = substr($string, 0, $breakpoint);
    }

    return $string . $pad;
 }
 
function clear_spaces($original_text){
	$pos = stripos($original_text, "  ");
	if ($pos === false) {
		return $original_text;
	} else {
		$ret_text = str_replace("  "," ",$original_text);
		return clear_spaces($ret_text);
	}
}

function replace_spanish_chars($original_text){

	$original_text=str_replace("á","&aacute;",$original_text);
	$original_text=str_replace("é","&eacute;",$original_text); 
	$original_text=str_replace("í","&iacute;",$original_text); 
	$original_text=str_replace("ó","&oacute;",$original_text); 
	$original_text=str_replace("ú","&uacute;",$original_text);
	$original_text=str_replace("ñ","&ntilde;",$original_text);
	$original_text=str_replace("ü","&uuml;",$original_text);
	
	$original_text=str_replace("Á","&Aacute;",$original_text);
	$original_text=str_replace("É","&Eacute;",$original_text); 
	$original_text=str_replace("Í","&Iacute;",$original_text); 
	$original_text=str_replace("Ó","&Oacute;",$original_text); 
	$original_text=str_replace("Ú","&Uacute;",$original_text);
	$original_text=str_replace("Ñ","&Ntilde;",$original_text);
	$original_text=str_replace("Ü","&Uuml;",$original_text);
	
	return $original_text;
	
}

function get_spanish_chars($original_text){

	$original_text=str_replace("&aacute;","á",$original_text);
	$original_text=str_replace("&eacute;","é",$original_text); 
	$original_text=str_replace("&iacute;","í",$original_text); 
	$original_text=str_replace("&oacute;","ó",$original_text); 
	$original_text=str_replace("&uacute;","ú",$original_text);
	$original_text=str_replace("&ntilde;","ñ",$original_text);
	$original_text=str_replace("&uuml;","ü",$original_text);
	
	$original_text=str_replace("&Aacute;","Á",$original_text);
	$original_text=str_replace("&Eacute;","É",$original_text); 
	$original_text=str_replace("&Iacute;","Í",$original_text); 
	$original_text=str_replace("&Oacute;","Ó",$original_text); 
	$original_text=str_replace("&Uacute;","Ú",$original_text);
	$original_text=str_replace("&Ntilde;","Ñ",$original_text);
	$original_text=str_replace("&Uuml;","Ü",$original_text);
	
	return $original_text;
	
}

function remove_spanish_chars($original_text){

	$original_text=str_replace("á","a",$original_text);
	$original_text=str_replace("é","e",$original_text); 
	$original_text=str_replace("í","i",$original_text); 
	$original_text=str_replace("ó","o",$original_text); 
	$original_text=str_replace("ú","u",$original_text);
	$original_text=str_replace("ñ","n",$original_text);
	$original_text=str_replace("ü","u",$original_text);
	
	$original_text=str_replace("Á","A",$original_text);
	$original_text=str_replace("É","E",$original_text); 
	$original_text=str_replace("Í","I",$original_text); 
	$original_text=str_replace("Ó","O",$original_text); 
	$original_text=str_replace("Ú","U",$original_text);
	$original_text=str_replace("Ñ","N",$original_text);
	$original_text=str_replace("Ü","U",$original_text);
	
	return $original_text;
	
}

function fix_html_string($original_text){
	$original_text = format_article_content($original_text);
	$original_text = replace_spanish_chars($original_text);
	
	$tidy = new Tidy();
	$options = array(
            'show-body-only' => true
    );

	$tidy->parseString($original_text, $options);
	$tidy->cleanRepair();
	
	return $tidy;
}

function format_article_content($html_text){
	$pos_body = stripos($html_text,"<body ");

	if($pos_body === false) {
		$pos_body = stripos($html_text,"<body>");
	}

	if($pos_body !== false) {
		$pos_body2 = strpos($html_text,">",$pos_body);
		$html_text = substr($html_text,$pos_body2+1,strlen($html_text));
		}

	$html_text = str_ireplace("</body>","",$html_text);
	
	return add_link_underline($html_text);
}

function add_link_underline($OriginalText){
	
	return preg_replace('/(<a\b[^><]*)>/i', '$1 style="text-decoration:underline;">', $OriginalText);
}

function clean_article_actions($OriginalText){
	
	return preg_replace("/\<a([^>]*)\>([^<]*)\<\/a\>/i", "$2", $OriginalText);
}

function show_pagination_horiz($static_url, $variable_url, $current_page, $records_in_page, $total_records){
	
	$total_pages = ceil($total_records/$records_in_page);
	
	$pagination = "";
	
	if($total_pages>1){

		$pagination = '<div class="pagination pagination-centered"><ul>';
	
		if($total_pages<=10){
			$start = 0;
			$end = $total_pages-1;
			if($current_page==1){
				$pagination.='<li class="disabled"><a href="#">&laquo;</a></li>';
			} else {
				$pagination.='<li><a href="'.$static_url.'?'.$variable_url.'&Page='.($current_page-1).'">&laquo;</a></li>';
			}
		} else {
			if($current_page<=5){
				$start = 0;
				$end = $start+10-1;
				if($current_page==1){
					$pagination.='<li class="disabled"><a href="#">&laquo;</a></li>';
				} else {
					$pagination.='<li><a href="'.$static_url.'?'.$variable_url.'&Page='.($current_page-1).'">&laquo;</a></li>';
				}
			} else {
				if($current_page+5>=$total_pages){
					$start = $total_pages-10;
					$end = $start+10-1;
					$pagination.='<li><a href="'.$static_url.'?'.$variable_url.'&Page='.($current_page-1).'">&laquo;</a></li>';
				} else {
					$start = $current_page-5;
					$end = $current_page+5-1;
					$pagination.='<li><a href="'.$static_url.'?'.$variable_url.'&Page='.($current_page-1).'">&laquo;</a></li>';
				}
			}
		}
		
		for($i=$start; $i<=$end; $i++){
			$xtra_current = "";
			if(($i+1) == $current_page) {
				$xtra_current = ' class="active"';
			}
			$pagination.='<li'.$xtra_current.'><a href="'.$static_url.'?'.$variable_url.'&Page='.($i+1).'">'.($i+1).'</a></li>';
		}
		
		if($current_page >= $total_pages){
			$pagination.='<li class="disabled"><a href="#">&raquo;</a></li>';
		} else {
			$pagination.='<li><a href="'.$static_url.'?'.$variable_url.'&Page='.($current_page+1).'">&raquo;</a></li>';
		}
		  
		$pagination.='</ul></div>';
	
	}
	
	return $pagination;
}

function show_pagination_ajax_horiz($function_call, $variable_url, $current_page, $records_in_page, $total_records, $frm_serialize = ""){
	
	$total_pages = ceil($total_records/$records_in_page);
	
	$pagination = "";
	
	if($total_pages>1){

		$pagination = '<div class="pagination pagination-centered"><ul>';
	
		if($total_pages<=10){
			$start = 0;
			$end = $total_pages-1;
			if($current_page==1){
				$pagination.='<li class="disabled"><a href="#">&laquo;</a></li>';
			} else {
				$pagination.='<li><a href="#" onclick="'.$function_call.'(\''.$variable_url.'&Page='.($current_page-1).'\',\''.$frm_serialize.'\');">&laquo;</a></li>';
			}
		} else {
			if($current_page<=5){
				$start = 0;
				$end = $start+10-1;
				if($current_page==1){
					$pagination.='<li class="disabled"><a href="#">&laquo;</a></li>';
				} else {
					$pagination.='<li><a href="#" onclick="'.$function_call.'(\''.$variable_url.'&Page='.($current_page-1).'\',\''.$frm_serialize.'\');">&laquo;</a></li>';
				}
			} else {
				if($current_page+5>=$total_pages){
					$start = $total_pages-10;
					$end = $start+10-1;
					$pagination.='<li><a href="#" onclick="'.$function_call.'(\''.$variable_url.'&Page='.($current_page-1).'\',\''.$frm_serialize.'\');">&laquo;</a></li>';
				} else {
					$start = $current_page-5;
					$end = $current_page+5-1;
					$pagination.='<li><a href="#" onclick="'.$function_call.'(\''.$variable_url.'&Page='.($current_page-1).'\',\''.$frm_serialize.'\');">&laquo;</a></li>';
				}
			}
		}
		
		for($i=$start; $i<=$end; $i++){
			$xtra_current = "";
			if(($i+1) == $current_page) {
				$xtra_current = ' class="active"';
			}
			$pagination.='<li'.$xtra_current.'><a href="#" onclick="'.$function_call.'(\''.$variable_url.'&Page='.($i+1).'\',\''.$frm_serialize.'\');">'.($i+1).'</a></li>';
		}
		
		if($current_page >= $total_pages){
			$pagination.='<li class="disabled"><a href="#">&raquo;</a></li>';
		} else {
			$pagination.='<li><a href="#" onclick="'.$function_call.'(\''.$variable_url.'&Page='.($current_page+1).'\',\''.$frm_serialize.'\');">&raquo;</a></li>';
		}
		  
		$pagination.='</ul></div>';
	
	}
	
	return $pagination;
}

function show_results_table($ColumnTiltes, $ColumnWidths, $RowContent){
	$table_result = '<table class="table table-hover"><thead><tr>';
	
	for($i=0; $i<count($ColumnTiltes); $i++){
		$column_width = "";
		if(isset($ColumnWidths[$i]) && $ColumnWidths[$i]!=""){
			$column_width = ' width="'.$ColumnWidths[$i].'"';	
		}
		$table_result.='<th'.$column_width.'>'.$ColumnTiltes[$i].'</th>';
	}
	
	$table_result.='</tr></thead><tbody>';

	for($i=0; $i<count($RowContent); $i++){
		$table_result.='<tr>';
		for($j=0; $j<count($RowContent[$i]); $j++){
      		$table_result.='<td>'.$RowContent[$i][$j].'</td>';
		}
		$table_result.='</tr>';
	}
	
	$table_result.='</tbody></table>';
	
	return $table_result;
}

function get_sql_query($SearchQry, $SearchType){
	
	$qry = "";
	$SearchQry = remove_palabras_comunes($SearchQry);
	$SearchQry_clean = mysql_real_escape_string($SearchQry);
	$SearchType_clean = mysql_real_escape_string($SearchType);
	
	switch($SearchType_clean){
		case "T":
			$qry_parts = explode(" ",$SearchQry_clean);
			$qry = "";
			for($i=0; $i<count($qry_parts);$i++){
				if($qry!=""){
					$qry.=" ";
				}
				if(strlen($qry_parts[$i])>2) {
					$qry.="+".$qry_parts[$i];
				}
			}
			break;
	
		case "C":
			$qry = $SearchQry_clean;
			break;
	
		default:
			$qry = '"'.$SearchQry_clean.'"';
			break;
	}
	
	return $qry;
}

function remove_palabras_comunes($original_text) {

	$open_tags = array('reformado','reformados','reformada','reformadas','vigente','vigentes','actualizada','actualizadas','actualizado','actualizados','codificada','codificadas','codificado','codificados','derogado','derogados','actuales','actual');
	$clos_tags = array(' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ');
	$ret_text = $original_text;

$string = $original_text;
$exceptions = array(
    "reformado"  => "", 
    "reformados" => "",
    "reformada" => "",
    "reformadas" => "",
    "vigente" => "",
    "vigentes" => "",
    "actualizada" => "",
    "actualizadas" => "",
    "actualizado" => "",
    "actualizados" => "",
    "codificada" => "",    
    "codificadas" => "",
    "codificado" => "",
    "codificados" => "",
    "derogado" => "",
    "derogados" => "",
    "derogada" => "",
    "derogadas" => "",
    "actuales" => "",
    "actual" => "",
    "REFORMADO"  => "", 
    "REFORMADOS" => "",
    "REFORMADA" => "",
    "REFORMADAS" => "",
    "VIGENTE" => "",
    "VIGENTES" => "",
    "ACTUALIZADA" => "",
    "ACTUALIZADAS" => "",
    "ACTUALIZADO" => "",
    "ACTUALIZADOS" => "",
    "CODIFICADA" => "",    
    "CODIFICADAS" => "",
    "CODIFICADO" => "",
    "CODIFICADOS" => "",
    "DEROGADO" => "",
    "DEROGADOS" => "",
    "DEROGADA" => "",
    "DEROGADAS" => "",
    "ACTUALES" => "",
    "ACTUAL" => ""
);
$strarray = explode(' ', $ret_text);
$newString = "";
for ($var = 0; $var < sizeof($strarray); $var++) {      
	  foreach($exceptions as $exception => $exceptionToReplace) {     
      if(@strpos($exception, $strarray[$var]) !== False){            
          $newString .= $exceptionToReplace.' ';
          $noChange = false;
          break;
        } else {        
          // NO change                    
          $noChange = true;
        }                 
    }  

    if($noChange)
     $newString .= $strarray[$var].' ';


}

return $newString;
}


function remove_non_used_code($original_text) {

	$open_tags = array('<p><a href="javascript:open_juris();"','<p><a href="javascript:open_doctrina();"');
	$clos_tags = array('</a></p>','</a></p>');
	
	$ret_text = $original_text;
	for($i=0; $i<count($open_tags); $i++){
		$offnext = 0;
		$ini_pos = stripos($ret_text,$open_tags[$i],$offnext);
		if($ini_pos !== false){
			$end_pos = stripos($ret_text,$clos_tags[$i],$offnext+$ini_pos+strlen($open_tags[$i]));
			while($ini_pos !== false && $end_pos !== false){
				$ret_text = substr($ret_text,0,$ini_pos) . substr($ret_text,$end_pos);
				$offnext = $ini_pos + strlen($clos_tags[$i]) ;
				$ini_pos = stripos($ret_text,$open_tags[$i],$offnext);
				if($ini_pos !== false){
					$end_pos = stripos($ret_text,$clos_tags[$i],$ini_pos+strlen($open_tags[$i]));
				}
			}	
		}
	}
	return $ret_text;
}

function set_no_paint_areas($original_text){
	$open_tags = array('title="', 'open_art(','class="MsoNormal" align="center"');
	$clos_tags = array('"', ')','>');
	
	$ret_text = $original_text;
	for($i=0; $i<count($open_tags); $i++){
		$offnext = 0;
		$ini_pos = stripos($ret_text,$open_tags[$i],$offnext);
		if($ini_pos !== false){
			$end_pos = stripos($ret_text,$clos_tags[$i],$offnext+$ini_pos+strlen($open_tags[$i]));
			while($ini_pos !== false && $end_pos !== false){
				$ini_pos+=strlen($open_tags[$i]);
				$end_pos+=strlen($clos_tags[$i]);
				$unsearched = set_str_no_readable(substr($ret_text,$ini_pos,($end_pos-$ini_pos-1)));
				$ret_text = substr($ret_text,0,$ini_pos) . $unsearched . substr($ret_text,$end_pos-1);
				$offnext = $ini_pos + strlen($unsearched) + strlen($clos_tags[$i]);
				$ini_pos = stripos($ret_text,$open_tags[$i],$offnext);
				if($ini_pos !== false){
					$end_pos = stripos($ret_text,$clos_tags[$i],$ini_pos+strlen($open_tags[$i]));
				}
			}	
		}
	}
	
	return $ret_text;
}

function get_tag_content($original_text, $open_tag, $close_tag){
	$ret_text = $original_text;
	$offnext = 0;
	
	$ini_pos = stripos($ret_text,$open_tag,$offnext);
	
	if($ini_pos !== false){		
		$ini_pos = stripos($ret_text,">",$ini_pos) + 1 ;
		
		if($ini_pos !== false){
			$end_pos = stripos($ret_text,$close_tag,$ini_pos);

			if($end_pos !== false){
				if($end_pos>$ini_pos){
					$ret_text = substr($ret_text,$ini_pos, $end_pos-$ini_pos);		
				}
			}
		}	
	}
	
	return $ret_text;
}

function set_str_no_readable($original_text){
	$interstr = "<!---->";
	$arr_string = str_split(replace_spanish_chars($original_text));
	$ret_text = implode($interstr,$arr_string);
	return $ret_text;
}

function remove_str_no_readable($original_text){
	$interstr = "<!---->";
	$ret_text = str_replace($interstr,"",$original_text);
	return $ret_text;
}

function fix_search_query($original_qry){
	global $con;

	$qry_parts = explode(" ",$original_qry);
	
	for($i=0; $i<count($qry_parts);$i++){
		$sql_xtra = "SELECT correcta FROM dex_diccionario WHERE incorrecta LIKE '".$qry_parts[$i]."'";
		$res_xtra = execute_query($sql_xtra, $con);
		if(total_records($res_xtra)>0){
			$qry_parts[$i] = get_result($res_xtra,0,'correcta');
		}
	}
	
	return trim(implode(" ",$qry_parts));
}

function paint_text_found($original_text, $SearchQry, $SearchType){
	
	$ret_text = set_no_paint_areas($original_text);

	$SearchQry_clean = fix_search_query(mysql_real_escape_string($SearchQry));
	$SearchType_clean = mysql_real_escape_string($SearchType);
	
	if($SearchQry_clean!=""){
		switch($SearchType_clean){
			case "T":
			case "C":
				$qry_parts = explode(" ",$SearchQry_clean);
				for($i=0; $i<count($qry_parts);$i++){
					$ret_text = paint_text($ret_text,$qry_parts[$i]);
					}
				break;
		
			default:
				$ret_text = paint_text($ret_text,$SearchQry_clean);
				break;
		}
	}
	
	return remove_str_no_readable($ret_text);
}

function paint_text($original_text, $phrase){

	$original_text = get_spanish_chars($original_text);

	if(strlen($phrase)>3){
		$original_text = str_replace("%","<!--percent-->",$original_text);
		$aux=$reemp=str_ireplace($phrase,'%s',$original_text); 
		$veces=substr_count($reemp,'%s'); 
		if($veces==0)return $original_text; 
		$palabras_originales=array(); 
		for($i=0;$i<$veces;$i++){ 
			  $palabras_originales[]='<span class="Resaltado">'.substr($original_text,strpos($aux,'%s'),strlen($phrase)).'</span>'; 
			  $aux=substr($aux,0,strpos($aux,'%s')).$phrase.substr($aux,strlen(substr($aux,0,strpos($aux,'%s')))+2); 
		} 
		
		return str_replace("<!--percent-->","%",vsprintf($reemp,$palabras_originales)); 
	} else {
		return $original_text;
	}
}

function get_style_top_bar($document_type){
	
	$ret_text = "";
	$bgColor1 = "";
	$bgColor2 = "";
	$TXTColor = "";
	
	switch($document_type){
		
		case 'AC':
			$bgColor1 = "C6A3CD";
			$bgColor2 = "502F57";
			$TXTColor = "FFFFFF";
			break;

		case 'EN':
			$bgColor1 = "B5A5D3";
			$bgColor2 = "47346B";
			$TXTColor = "FFFFFF";
			break;

		case 'LD':
			$bgColor1 = "A7BAD6";
			$bgColor2 = "3A527C";
			$TXTColor = "FFFFFF";
			break;

		case 'TI':
			$bgColor1 = "B7D9DF";
			$bgColor2 = "39727D";
			$TXTColor = "FFFFFF";
			break;

		case 'DD':
			$bgColor1 = "A8D7C4";
			$bgColor2 = "3A7C61";
			$TXTColor = "FFFFFF";
			break;

		case 'JP':
			$bgColor1 = "96CA93";
			$bgColor2 = "3F7B3C";
			$TXTColor = "FFFFFF";
			break;

		case 'TR':
			$bgColor1 = "DCDAAF";
			$bgColor2 = "7E7B38";
			$TXTColor = "FFFFFF";
			break;

		case 'CP':
			$bgColor1 = "D0766C";
			$bgColor2 = "6D2B23";
			$TXTColor = "FFFFFF";
			break;

		case 'DJ':
			$bgColor1 = "F48A8A";
			$bgColor2 = "AA0F0F";
			$TXTColor = "FFFFFF";
			break;

		case 'NEW':
			$bgColor1 = "FFC891";
			$bgColor2 = "CD6701";
			$TXTColor = "FFFFFF";
			break;

		default:
			$bgColor1 = "";
			$bgColor2 = "";
			$TXTColor = "";
			break;
	}

	if($bgColor1!="" && $bgColor2!=""){
		$ret_text.='.navbar-inner {background-image: linear-gradient(to bottom, #'.$bgColor1.', #'.$bgColor2.');}' . "\n";
	}

	if($TXTColor!=""){
		$ret_text.='.TitleCenter {color: #'.$TXTColor.'; text-shadow:1px 1px 0px #000}' . "\n";
	}
	
	return $ret_text;	
}

function get_tipo_ley_nombre($tipo_ley_id){
	global $con;
	
	$sql_xtra = "SELECT tipoley_nombre FROM dex_tipo_ley WHERE tipoley_id = '".$tipo_ley_id."'";
	$res_xtra = execute_query($sql_xtra, $con);
	return get_result($res_xtra,0,"tipoley_nombre");
}

function get_sector_nombre($mat_id){
	global $con;
	
	$mat_id_arr = explode(",",$mat_id);
	
	$sql_xtra = "SELECT g.grup_nombre FROM dex_materia_grupo g, dex_materia m WHERE m.mat_id = '".$mat_id_arr[0]."' AND m.grup_id = g.grup_id";
	$res_xtra = execute_query($sql_xtra, $con);
	return get_result($res_xtra,0,"grup_nombre");
}

function get_sort_encoded_field($active_sort, $this_sort){
	//$active_sort es el filtro aplicado en este momento: "t1.doc_titulo ASC"
	//$this_sort es el filtro que queremos aplicar para esste link: "t1.doc_titulo ASC"
	$ret_text = $this_sort;
	$tmp_arr = explode(" ",$active_sort);
	$tmp_arr2 = explode(" ",$this_sort);
	if(count($tmp_arr)==2 && count($tmp_arr2)==2){
		if($tmp_arr[0]==$tmp_arr2[0]){
			if(strpos($tmp_arr[1],"ASC") !== false){
				$ret_text = $tmp_arr2[0]." DESC";
			} else {
				return "";
			}
		}
	}
	return encode($ret_text);
}

function get_sort_icon($active_sort, $this_sort){
	//$active_sort es el filtro aplicado en este momento: "t1.doc_titulo ASC"
	//$this_sort es el filtro que queremos aplicar para esste link: "t1.doc_titulo ASC"

	$ret_text = "";
	$tmp_arr = explode(" ",$active_sort);
	$tmp_arr2 = explode(" ",$this_sort);
	if(count($tmp_arr)==2 && count($tmp_arr2)==2){
		if($tmp_arr[0]==$tmp_arr2[0]){
			if(strpos($tmp_arr[1],"ASC") !== false){
				$ret_text = '&nbsp;<i class="icon-sort-down icono-morado"></i>';
			} else {
				$ret_text = '&nbsp;<i class="icon-sort-up icono-morado"></i>';
			}
		}
	}
	return $ret_text;
}

function get_similar_frase($frase, $Link, $closeLink = ""){
	$changed = false;
	
	$sep = " ";
	
	$frase_arr = explode($sep,$frase);
	
	if(count($frase_arr)<=1){
		if(strpos($frase,"+") !== false){
			$sep = "+";
			$frase_arr = explode($sep,$frase);
		}
	}
	
	
	for($i=0; $i<count($frase_arr); $i++){
		$palabra = $frase_arr[$i];

		if(strlen($palabra)>2){
			$busqueda = new CompareStringArray($palabra, $_SESSION['CEPWEB_ArrPalabras']);
	
			$busqueda->compare(false,60);
	
			if($busqueda->meta_perc_key && strtolower($busqueda->matched_value) != strtolower($palabra)){
				$frase_arr[$i] = $busqueda->matched_value;
				$changed = true;
			}
		}
	}
	
	if($changed){
		return '<small class="muted">Tal vez quiso decir: </small><a href="'.$Link.implode($sep,$frase_arr).$closeLink.'">"'.implode(" ",$frase_arr).'"</a>';
	} else {
		return '';	
	}
}

function IsDeveloper(){
    
    $ret = false;
    $array_develop_ips = array("181.199.53.247");
    
    if (in_array ($_SERVER['REMOTE_ADDR'], $array_develop_ips)) {
        $ret = true;
    }
    
    return $ret;
}

// Add slashes for SQL
function ew_AdjustSql($val) {
	$val = addslashes(trim($val));
	return $val;
}

function BasicSearchSQL($Keyword)
{
    $sKeyword = ew_AdjustSql($Keyword);
    $sql = "";
    $sql .= "t1.doc_titulo" . " LIKE '%" . $sKeyword . "%' OR ";
    $sql .= "t1.num_ley" . " LIKE '%" . $sKeyword . "%' OR ";
    $sql .= "t1.doc_ro" . " LIKE '%" . $sKeyword . "%' OR ";
    $sql .= "t1.evolucion_xml" . " LIKE '%" . $sKeyword . "%' OR ";
    $sql .= "t1.doc_descripcion" . " LIKE '%" . $sKeyword . "%' OR ";
    if (substr($sql, -4) == " OR ") $sql = substr($sql, 0, strlen($sql) - 4);
    return $sql;
}
function BasicSearchSQLAnd($Keyword)
{
$ret_text = $Keyword;
$strarray = explode(' ', $ret_text);
$wsql = "";
for ($var = 0; $var < sizeof($strarray); $var++) {    
	if (strlen($strarray[$var]) > 2){
		$wsql.= " doc_titulo LIKE '%".$strarray[$var]."%'" . " AND ";		
}
}
$wsqlresult = $wsql;// "(" .substr($wsql,0,strlen($wsql)-5). ")";
return $wsqlresult;
}
?>